import { ApplicationCommandOptionData, AutocompleteInteraction, CommandInteraction, PermissionResolvable, CommandInteractionOption, CacheType, ApplicationCommandOptionType } from "discord.js"

export interface SlashCommand {
    name: string
    description: string
    cooldown?: number
    permission: PermissionResolvable[]
    guildID?: string
    ownerOnly: boolean
    guildOnly: boolean
    args: ApplicationCommandOptionData[]
    autocomplete?(int: AutocompleteInteraction): Promise<void>
    execute(int: CommandInteraction): Promise<any>
}

export function createArgumentsObject<T> (data: readonly CommandInteractionOption<CacheType>[]): T {
    var a: {
        [key: string]: any
    } = {};
    for (const arg of data) {
        switch (arg.type) {
            case ApplicationCommandOptionType.User:
                a[arg.name] = arg.member || arg.user;
                break;
            default:
                a[arg.name] = arg.value;
        }
    }
    return a as T;
}